<html>
<head>
<meta charset="UTF-8" />
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta name="viewport" content="width=device-width, initial-scale=1">

<script type="text/javascript" src="http://code.jquery.com/jquery-1.10.2.js"></script>
<script type="text/javascript" src="scripts/BinaryArray.js"></script>
<script type="text/javascript" src="scripts/crypto.des.js"></script>

<style type="text/css">
table {
	border-collapse: collapse;
}

table, th, td {
	border: 1px solid black;
	text-align: center;
	font-family: Consolas;
	margin: 5px;
	padding-left: 5px;
	padding-right: 5px;
}

</style>

</head>
<body>

<div style="display: flex">
	<div id="divResult1"> </div>
	<div id="divResult2">
		<div id="divResult21"> </div>
		<input type="checkbox" id="chkDetail"> İkili değerleri göster. <br />
		<input type="checkbox" id="chkShowHex"> Heksadesimal değerleri göster. <br />
		
		<div id="divResult22"> </div> 
	</div>
</div>

<script type="text/javascript">
	

	var table = "<table>";
	table += "<tr>";
	table += "<td><strong>Değer<strong></td>";
	for (var i = 1; i < 9; i++) {
		table += "<td><strong>SBOX " + i + "</strong></td>";
	}
	table += "</tr>";

	for (var i = 0; i < 64; i++) {
		var n = BinaryArrayFromInt(i, 6);
		table += "<tr>";
		table += "<td>" + i.toString().padStart(2, '0') + "|" + n + "</td>";
		for (var j = 0; j < 8; j++) {
			var s = DES_CONSTANTS.SBOX[j][i];
			var v = BinaryArrayFromInt(s, 4);
			table += "<td>" /* + s.toString().padStart(2, '0') + "|" */ + v + "</td>";
		}
		table += "</tr>";
	}
	table += "</table>";
	$("#divResult1").append(table);
	



	var frequency_table = DES_CONSTANTS.SBOX.map(sbox => Array(16).fill(0).map((x,i) => i).map(k => sbox.map(x => x == k ? 1 : 0).reduce((x,y) => x+y, 0) ))

	var table = "<table>";
	table += "<tr>";
	table += "<td><strong>SBOX<strong></td>";
	for (var i = 0; i < 16; i++) {
		table += "<td>";
		table += "<strong>" + i.toString().padStart(2, '0') + "</strong><br />";
		table += BinaryArrayFromInt(i, 4).toString();
		table += "</td>";
	}
	for (var i = 0; i < 8; i++) {
		table += "<tr>";
		table += "<td><strong>" + (i+1) + "</strong></td>";
		for (var j = 0; j < 16; j++) {

			table += "<td>" + frequency_table[i][j] + "</td>";
		}
		table += "</tr>";
	}
	table += "</tr>";

	table += "</table>";
	$("#divResult21").append(table);




var showTable3 = function() {

	$("#divResult22").html("");

	var showBinaryValue = $("#chkDetail").prop('checked');
	var showHex = $("#chkShowHex").prop('checked');

	var table3 = DES_CONSTANTS.SBOX.map(sbox => Array(16).fill(0).map((x,i) => i).map(x => sbox.map((y,j) => (y == x ? 1 : 0) * (j+1)).reduce((a,b) => b != 0 ? a.concat([b-1]) : a, []) ));


	if (showHex)
		table3_1 = table3.map(sbox => sbox.map(x => x.map(y => BinaryArrayFromInt(y, 8).toString('hex')).join(',')));
	else 
		table3_1 = table3.map(sbox => sbox.map(x => x.map(y => y.toString().padStart(2, '0')).join(',')));
	
	var table = "<table>";
	table += "<tr>";
	table += "<td><strong><strong></td>";
	for (var i = 0; i < 8; i++) {
		table += "<td><strong>SBOX " + (i+1) + "</strong></td>";
	}
	for (var i = 0; i < 16; i++) {
		table += "<tr>";
		table += "<td><strong>" + i.toString().padStart(2, '0') + "</strong></td>";
		for (var j = 0; j < 8; j++) {
			table += "<td>";
			table += table3_1[j][i];
			if (showBinaryValue){
				for (var k = 0; k < table3[j][i].length; k++){
					table += "<br />" + BinaryArrayFromInt(table3[j][i][k], 6).toString();
				}
			}
			table += "</td>";

		}
		table += "</tr>";
	}
	table += "</tr>";

	table += "</table>";
	$("#divResult22").append(table);
}

showTable3();

$("#chkDetail").on('change', function(){

	showTable3();
});

$("#chkShowHex").on('change', function(){
	showTable3();
});

</script>

</body>
</html>